diff a/src/hotspot/share/opto/type.cpp b/src/hotspot/share/opto/type.cpp
--- a/src/hotspot/share/opto/type.cpp
+++ b/src/hotspot/share/opto/type.cpp
@@ -88,11 +88,11 @@
   { Bad,             T_ILLEGAL,    "vectorx:",      false, Op_VecX,              relocInfo::none          },  // VectorX
   { Bad,             T_ILLEGAL,    "vectory:",      false, Op_VecY,              relocInfo::none          },  // VectorY
   { Bad,             T_ILLEGAL,    "vectorz:",      false, Op_VecZ,              relocInfo::none          },  // VectorZ
 #endif
   { Bad,             T_ADDRESS,    "anyptr:",       false, Op_RegP,              relocInfo::none          },  // AnyPtr
-  { Bad,             T_ADDRESS,    "rawptr:",       false, Op_RegP,              relocInfo::none          },  // RawPtr
+  { Bad,             T_ADDRESS,    "rawptr:",       false, Op_RegP,              relocInfo::external_word_type },  // RawPtr
   { Bad,             T_OBJECT,     "oop:",          true,  Op_RegP,              relocInfo::oop_type      },  // OopPtr
   { Bad,             T_OBJECT,     "inst:",         true,  Op_RegP,              relocInfo::oop_type      },  // InstPtr
   { Bad,             T_OBJECT,     "ary:",          true,  Op_RegP,              relocInfo::oop_type      },  // AryPtr
   { Bad,             T_METADATA,   "metadata:",     false, Op_RegP,              relocInfo::metadata_type },  // MetadataPtr
   { Bad,             T_METADATA,   "klass:",        false, Op_RegP,              relocInfo::metadata_type },  // KlassPtr
@@ -4538,11 +4538,11 @@
   case Constant:
     if (WizardMode || Verbose) {
       ResourceMark rm;
       stringStream ss;
 
-      st->print(" ");
+      st->print(" " INTPTR_FORMAT, p2i(const_oop()));
       const_oop()->print_oop(&ss);
       // 'const_oop->print_oop()' may emit newlines('\n') into ss.
       // suppress newlines from it so -XX:+Verbose -XX:+PrintIdeal dumps one-liner for each node.
       char* buf = ss.as_string(/* c_heap= */false);
       StringUtils::replace_no_expand(buf, "\n", "");
@@ -5155,10 +5155,11 @@
   _ary->dump2(d,depth,st);
   _interfaces->dump(st);
 
   switch( _ptr ) {
   case Constant:
+    st->print(" " INTPTR_FORMAT " ", p2i(const_oop()));
     const_oop()->print(st);
     break;
   case BotPTR:
     if (!WizardMode && !Verbose) {
       if( _klass_is_exact ) st->print(":exact");
